# Core

## if
**Пример**:
```liin
> if true
    > print "hi!"
> else
    > print "not hi ;("
```
**Аргументы**: [**0**]: bool
**Возвращает**: -
**Описание**: Выполняет следующий за командой блок кода. Если сразу после if идёт else, то при невыполнении условия, выполняется блок, идущий после блока if

## count
**Пример**:
```liin
! i = 1
> count 3
    > print i
    ! i += 1
```
**Аргументы**: [**0**]: int
**Возвращает**: -
**Описание**: Выполняет следующий за командой блок столько раз, сколько указано в первом аргументе

## while
**Пример**:
```liin
> while true
    > print "endless"
```
**Аргументы**: [**0**]: bool
**Возвращает**: -
**Описание**: Обычный цикл while, выполняет следующий за командой блок, пока первый аргумент = истина

## run
**Пример**:
```liin
!> greeting
    > print "hi!"
> run "greeting"
```
**Аргументы**: [**0**]: String
**Возвращает**: -
**Описание**: Выполняет объявленный блок и возвращается на место

## input
**Пример**:
```liin
! inp << input
```
**Аргументы**: -
**Возвращает**: any
**Описание**: Читает строку из консоли или получает следующий элемент из массива ввода (если язык используется в качестве модуля)


# Base

## print
**Пример**:
```liin
> print 1, 2, 3, 4, 5
```
**Аргументы**: [**X**]: any
**Возвращает**: -
**Описание**: Выводит все переданные аргументы через пробел

## liin
**Пример**:
```liin
> liin
```
**Аргументы**: -
**Возвращает**: -
**Описание**: Выводит лого liin и информацию о текущей версии языка

## show_context
**Пример**:
```liin
> show_context
```
**Аргументы**: -
**Возвращает**: -
**Описание**: Выводит весь контекст для выражений и указания для блоков _([начало, конец, отступ изначальный, отступ блока])_


# Files

## file
**Пример**:
```liin
! f << file "text.txt"
```
**Аргументы**: [**0**]: String
**Возвращает**: File
**Описание**: Возвращает объект файла для дальнейшей работой с ним

## file_create
**Пример**:
```liin
> file_create f
```
**Аргументы**: [**0**]: File
**Возвращает**: -
**Описание**: Создаёт указанный файл

## file_copy
**Пример**:
```liin
> file_copy f, "text2.txt"
```
**Аргументы**: [**0**]: File, [**1**]: String
**Возвращает**: File
**Описание**: Создаёт копию указанного файла по указанному пути

## file_write
**Пример**:
```liin
> file_write f, "123"
```
**Аргументы**: [**0**]: File, [**1**]: any
**Возвращает**: -
**Описание**: Записывает указанную строку в указанный файл

## file_writeb
**Пример**:
```liin
. На данный момент с байтами работа не закончена
> file_writeb f, bytes
```
**Аргументы**: [**0**]: File, [**1**]: List<int>
**Возвращает**: -
**Описание**: Записывает указанные байты в указанный файл

## file_read
**Пример**:
```liin
! str << file_read f
```
**Аргументы**: [**0**]: File
**Возвращает**: String
**Описание**: Возвращает всё содержимое указанного файла

## file_readb
**Пример**:
```liin
. На данный момент с байтами работа не закончена
! bytes << file_readb f
```
**Аргументы**: [**0**]: File
**Возвращает**: List<int>
**Описание**: Возвращает всё содержимое указанного файла в виде байтов

## file_append
**Пример**:
```liin
> file_append f, content
```
**Аргументы**: [**0**]: File, [**1**]: any
**Возвращает**: -
**Описание**: Записывает указанную строку в конец указанного файла

## file_exists
**Пример**:
```liin
! e << file_exists f
```
**Аргументы**: [**0**]: File
**Возвращает**: bool
**Описание**: Возвращает true, если указанный файл существует и false, если нет

## file_remove
**Пример**:
```liin
> file_remove f
```
**Аргументы**: [**0**]: File
**Возвращает**: -
**Описание**: Удаляем указанный файл


# Strings

## str
**Пример**:
```liin
! s << str 1+0, 1+1, 1+2, "45"
```
**Аргументы**: [**X**]: any
**Возвращает**: String
**Описание**: Соединяет разные выражения как строку

## str_slice
**Пример**:
```liin
! s << str_slice "123", 0, 1
```
**Аргументы**: [**0**]: String, [**1**]: int, [**2**]: int
**Возвращает**: String
**Описание**: Возвращает часть указанной строки в указанном промежутке

## str_length
**Пример**:
```liin
! l << str_length "Hi!"
```
**Аргументы**: [**0**]: String
**Возвращает**: int
**Описание**: Возвращает длину указанной строки

## str_color_rgb
**Пример**:
```liin
! s << str_color_rgb "red!", 255, 0, 0, true
```
**Аргументы**: [**0**]: String, [**1**]: num, [**2**]: num, [**3**]: num, ?[**4**]: bool
**Возвращает**: String
**Описание**: Взвращает строку с добавленными цветовыми кодам к указанной строке по RGB

## str_color
**Пример**:
```liin
! s << str_color "blue!", 57
```
**Аргументы**: [**0**]: String, [**1**]: int, ?[**2**]: bool
**Возвращает**: String
**Описание**: Взвращает строку с добавленными цветовыми кодам к указанной строке по XTerm

## str_replace_first
**Пример**:
```liin
! s << str_replace_first "111", "1", "3"
```
**Аргументы**: [**0**]: String, [**1**]: String, [**2**]: String
**Возвращает**: String
**Описание**: Возвращает указанную строку с заменённым первым совпадением указанного шаблона на другой указанный шаблон 

## str_replace_all
**Пример**:
```liin
! s << str_replace_all "111", "1", "3"
```
**Аргументы**: [**0**]: String, [**1**]: String, [**2**]: String
**Возвращает**: String
**Описание**: Возвращает указанную строку с заменёнными всеми совпадениями указанного шаблона на другой указанный шаблон 

## str_contains
**Пример**:
```liin
! s << str_contains "123", "5"
```
**Аргументы**: [**0**]: String, [**1**]: String
**Возвращает**: bool
**Описание**: Возвращает true, если в указанной строке есть указанный шаблон и false, если нет

## str_low
**Пример**:
```liin
! s << str_low "HeLlO!"
```
**Аргументы**: [**0**]: String
**Возвращает**: String
**Описание**: Возвращает указанную строку, приведённую к нижнему регистру

## str_up
**Пример**:
```liin
! s << str_up "HeLlO!"
```
**Аргументы**: [**0**]: String
**Возвращает**: String
**Описание**: Возвращает указанную строку, приведённую к верхнему регистру